/*    
   Disclaimers
   ALL INFORMATION PROVIDED WITHIN OR OTHERWISE ASSOCIATED WITH THIS 
   PUBLICATION  INCLUDING, INTER ALIA, ALL SOFTWARE CODE, IS PROVIDED
   "AS IS, AND FOR EDUCATIONAL PURPOSES ONLY. INTEL RETAINS ALL 
   OWNERSHIP INTEREST IN ANY INTELLECTUAL PROPERTY RIGHTS ASSOCIATED 
   WITH THIS INFORMATION AND NO LICENSE, EXPRESS OR IMPLIED, BY 
   ESTOPPEL OR OTHERWISE, TO ANY INTELLECTUAL PROPERTY RIGHT IS GRANTED
   BY THIS PUBLICATION OR AS A RESULT OF YOUR PURCHASE THEREOF. INTEL 
   ASSUMES NO LIABILITY WHATSOEVER AND INTEL DISCLAIMS ANY EXPRESS OR 
   IMPLIED WARRANTY RELATING TO THIS INFORMATION INCLUDING, BY WAY OF 
   EXAMPLE AND NOT LIMITATION, LIABILITY OR WARRANTIES RELATING TO 
   FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABILITY, OR THE INFRINGEMENT
   OF ANY INTELLECTUAL PROPERTY RIGHT ANYWHERE IN THE WORLD.


   THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS AND ANY EXPRESS OR 
   IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
   WARRANTIES    OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
   ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
   INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
   STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
   IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
   POSSIBILITY OF SUCH DAMAGE.
*/
/*
   Lab 4.2: Endian-Neutral Code Using Runtime Test for Byte Swapping:
   Modify the program from Lab 4.1 to use byte swapping and a runtime test
   (instead of compiler directive) to test for the endianness of the system
   the code is running on. The code must initalize a short varible one byte
   at a time, to the value of 0x1234, and print out the whole value in its
   natrual data type. Then endian-neutral code should print out the same
   results wwhether the code is compiled for and executed on a big-endian
   or little-endian machine.

   The result should execute and print as follows:
      > 1234
*/

#include <stdio.h>

/*
   Define a byte swapping macro to swap two bytes, and a union to use for
   a runtime Endianness test of the system.
*/
#define SWAP_TWO_BYTES(X) (((X & 0xff00) >> 8) | ((X & 0x00ff) << 8))

union
{
    char Array[2];
    short Data;
} EndianTestUnion;

int main()
{
    short Val;
    char *pVal;
    pVal = (char *) &Val;

    /* 
       The next 4 lines are used to initialize the information
       for the endianness test.
    */

    int x;
    char c = 'a';
    for (x = 0; x < 2; x++)
        EndianTestUnion.Array[x] = c++;

    /*
       The following two lines assumes big-endian architecture to
       initialize the variable Val to 0x1234.
    */
    pVal[0] = 0x12;
    pVal[1] = 0x34;

    /*
       Test the endianness of the system and byte swap for
       little-endian systems.
    */
    if (EndianTestUnion.Data == 0x6162)
        ; /* Do nothing */
    else
        Val = SWAP_TWO_BYTES (Val);
    
    printf("%x\n", Val);
    return 0;
}

